/*************************************************************************
 *                                                                       *
 *                              SCENE4.HXX                               *
 *                                                                       *
 *************************************************************************
 
   DESCRIPTION
	   Script for level 4	 
 
   PROGRAMMERS
		
 
   FUNCTIONS
 
   TABS : 4
 
 *************************************************************************/

/**************************** I N C L U D E S ****************************/

/*************************** C O N S T A N T S ***************************/

#define TICKS_SCAN_NOTICE  5    // scanning message
#define TICKS_SCAN_LIGHT_1 50    // green light 1
#define TICKS_SCAN_LIGHT_2 75    // green light 2
#define TICKS_SCAN_LIGHT_3 100   // green light 3   
#define TICKS_SCAN_LIGHT_4 125   // green light 4
#define TICKS_SCAN_DOOR_OPENS 180   // Door opens
#define TICKS_SCAN_DOOR_OPENED 181   // Door opened

/***************************** G L O B A L S *****************************/

//VarKey101	- 0 prebroke, 1 stuck/broke, 2 stuck/fixed, 3 normal
               
//VarKey102	- Chot attack in s3_st07 (1 spawns then)
//VarKey103	- Outskirts lights turned on - Door in s3_s12 unlocked
//VarKey104	- Laserbeam on/off in sewer
//VarKey105	- 
//			  0 : Player is in sewer (sound samples change)
//			  1 : Player is in Street/Factory
//			  2 : Player is in Laboratory	
//VarKey106	- Open Lab Door
//varkey107	- Special Security Door in Street 07
//varkey108	- Activate the Behemoth Creation
//VarKey109	- Laserwall in s3_f1_b01
//VarKey110 - status bits
//				bit 0 - chotbehemoth sequence not executed yet
//				bit 1 - chotbehemoth sequence is executing

/****************************** M A C R O S ******************************/




SubRoutine(InitSceneSound13)
{
			//ambient sound Fx
			#include	"messiahscripts\stages\scene4sfx.hxx"
}



/**************************** R O U T I N E S ****************************/

SubRoutine(InitScene13)
{
			InitActor(Bob1,0,Gactorangle,"S3_s14")
			#include    "messiahscripts\enemies\c1_sewer_e.spt"
			#include    "messiahscripts\enemies\c1_lab_e.spt"
			#include    "messiahscripts\enemies\c1_factory_e.spt"

			// Reset all the variables
         float(_set,VarKey101,0);
			float(_set,VarKey102,0);
			float(_set,VarKey103,0);
			float(_set,VarKey104,0);
			float(_set,VarKey105,0);
			float(_set,VarKey106,0);
			float(_set,VarKey107,0);
			float(_set,VarKey108,0);
			float(_set,VarKey109,0);
			float(_set,VarKey110,1);
			float(_set,OpenDoor,0);
			float(_set,MissionLevel1,0);
			float(_set,MissionLevel2,0);
			float(_set,MissionLevel3,0);
			float(_set,MissionLevel4,0);
			float(_set,WeaponDelay01,0);
			float(_set,WeaponDelay02,0);
			float(_set,WeaponDelay03,0);
			float(_set,CameraPan,0);
			float(_set,LiftMsg,0);
			float(_set,timer,0);
			float(_set,timer2,0);
			float(_set,timer3,0);
			float(_set,timer4,0);

			MissionObjective("Old Town Outskirts               ",60,400);
			MissionObjective("---------------------------------",70,400);
			MissionObjective("Primary Objective :              ",80,400);
			MissionObjective("   Find main power generator and ",90,400);
			MissionObjective("   restore power to old town.    ",100,400);


			callsub(InitSceneSound13);
}

SubRoutine(MainScene13)
{

/////////////////////////
//// SECTOR 3 SCRIPT ////
/////////////////////////

	if(VarKey104<2)
	{
		vector(_set,gactorpos,-7460,-880,14573);
		vector(_set,gactorine,-7670,-880,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);

		vector(_set,gactorpos,-7670,-880,14573);
		spawnparticle(fx_flare,-1,gactorpos,emptyvector,fx_coplaserflarered);
		if(vrnd<20)
		{
			vector(_set,gactorine,0,15,0);
			spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);
		}

		vector(_set,gactorpos,-7460,-830,14573);
		vector(_set,gactorine,-8075,-830,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);

		vector(_set,gactorpos,-7460,-780,14573);
		vector(_set,gactorine,-8075,-780,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);

		vector(_set,gactorpos,-7460,-730,14573);
		vector(_set,gactorine,-8075,-730,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);

		vector(_set,gactorpos,-7460,-680,14573);
		vector(_set,gactorine,-8075,-680,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);

		vector(_set,gactorpos,-7460,-630,14573);
		vector(_set,gactorine,-8075,-630,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);

		vector(_set,gactorpos,-7460,-580,14573);
		vector(_set,gactorine,-8075,-580,14573);
		callsub(LaserStrip,gactorpos,gactorine,fx_yellow,0);
	}

	//////////////////
	//	VSETACTIVE	//
	//////////////////

	if(VSetActive=="s3_s12")
	{
		CurEnvTriggerSet("s3_s12","sdoor1");
		if(VarKey103==0)
		{
			float(_set,TmpFloat,0xff0000);
			call(expset1,1,TmpFloat,0);
		}
		else
		{
			float(_set,TmpFloat,0x00ff00);
			call(expset1,1,TmpFloat,0);
		}

		if(VarKey104==2)
		{
			if(vrnd<15)
			{
				vector(_set,tmpvector,0,0,0);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_setx,tmpvector,tmpfloat);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_sety,tmpvector,tmpfloat);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_setz,tmpvector,tmpfloat);
				vector(_set,Gactorpos,-7468,-777,14373);
				vector(_add,gactorpos,tmpvector);
				SpawnParticle(fx_sparks,-1,Gactorpos,EmptyVector,-1);

				vector(_set,tmpvector,238,177,10);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,100);
			}
		}
	}
	
	
	if(VSetActive=="s3_s14")
	{
		CurEnvTriggerSet("s3_s14","door1");
		if(VarKey103==0)
		{
			float(_set,TmpFloat,0xff0000);
			call(expset1,1,TmpFloat,0);
		}
		else
		{
			float(_set,TmpFloat,0x00ff00);
			call(expset1,1,TmpFloat,0);
		}
	}


	if(VSetActive=="s3_f1b01")
	{
		float(_add,timer,1);

		CurEnvTriggerSet("s3_f1b01","lift");
		if(VKeyObjFrame==3 && VKeyObjTriggered==0 && VarKey101<5)
		{
			float(_set,TmpFloat,0xff0000);
   			call(expset1,1,TmpFloat); //lift arrowsw
   			call(expset2,1,TmpFloat); //floor indicator
			float(_set,VarKey101,5);
		}
		if (VarKey101==1 && VKeyObjTriggered==0 && VKeyObjFrame!=0) // is elevator in broken state?
		{
			if(vrnd<15)
			{
				vector(_set,tmpvector,0,0,0);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_setx,tmpvector,tmpfloat);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_sety,tmpvector,tmpfloat);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_setz,tmpvector,tmpfloat);
				vector(_set,Gactorpos,6185,-658,16333);
				vector(_add,gactorpos,tmpvector);
				SpawnParticle(fx_sparks,-1,Gactorpos,EmptyVector,-1);

				vector(_set,tmpvector,238,177,10);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,100);
			}
			if(timer==10 && vrnd<30)
			{
				vector(_set,Gactorpos,6200,-658,16333);
				spawnparticle(fx_smallexplosion,-1,gactorpos,emptyvector,fx_antirotate8);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,1500);
				sample(SFXVentSmall,Gactorpos);
			}
			if(timer==15 && vrnd<50)
			{
				vector(_set,Gactorpos,6220,-670,16333);
				spawnparticle(fx_smallexplosion,-1,gactorpos,emptyvector,fx_antirotate8);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,1500);
				sample(SFXVentSmall,Gactorpos);
			}
			if(timer==30 && vrnd<50)
			{
				vector(_set,Gactorpos,6185,-658,16333);
				spawnparticle(fx_smallexplosion,-1,gactorpos,emptyvector,fx_antirotate8);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,1500);
				sample(SFXVentSmall,Gactorpos);
			}

			#define BROKE_COLOR1  0x000000
			#define BROKE_COLOR2  0xff0000
			if (timer&=16)
			{
      			float(_set,TmpFloat,BROKE_COLOR1);  
			}
			else
			{
      			float(_set,TmpFloat,BROKE_COLOR2);  
			}
   			call(expset1,1,TmpFloat); //lift arrowsw
   			call(expset2,1,TmpFloat); //floor indicator
			if(timer==3)
			{
				message("System Malfunction",120,10);
				sample(SFXMechanicalFailure,-1);
				sample(SFXLiftBroken,-1);
				vector(_set,Gactorpos,6388,-551,16351);
				sample(SFXBazookaExplode,Gactorpos);
				sample(SFXGlobeIdle,Gactorpos);
			}
			if(timer==5)
			{
				vector(_set,tmpvector,250,159,8);
				vector(_set,Gactorpos,6639,-67,16886);
				spawnlight(LightPulseOmni4,-1,Gactorpos,tmpvector,EmptyVector,50);

				vector(_set,Gactorpos,6180,-67,16886);
				spawnlight(LightPulseOmni4,-1,Gactorpos,tmpvector,EmptyVector,50);

				vector(_set,Gactorpos,6180,-67,16369);
				spawnlight(LightPulseOmni4,-1,Gactorpos,tmpvector,EmptyVector,50);

				vector(_set,Gactorpos,6639,-67,16369);
				spawnlight(LightPulseOmni4,-1,Gactorpos,tmpvector,EmptyVector,50);
			}
			if(timer>=65)
			{
				float(_set,timer,4);
			}
		}
		else
		{
   			float(_set,TmpFloat,0x777777);  // light gray
   			float(_set,TmpFloat1,0x00ff22) ; // green
   			call(expset1,4,TmpFloat,TmpFloat1); //lift direction
   			float(_set,TmpFloat,0x444444);  // dark gray
   			float(_set,TmpFloat2,0xdddddd); // white
   			call(expset2,3,TmpFloat,TmpFloat2); //floor indicator
			if(VKeyObjFrame==0 && VKeyObjTriggered==0 && LiftMsg==1)
			{
				message("Sub Basement",120,10);
				float(_set,LiftMsg,0);
			}
			if(VKeyObjFrame==3 && VKeyObjTriggered==0 && LiftMsg==1)
			{
				message("Operations Level",120,10);
				float(_set,LiftMsg,0);
			}
		}
	}
	if(VSetActive=="s3_f1_03")
	{
		CurEnvTriggerSet("s3_f1_03","lift");
		float(_set,TmpFloat,0x777711);  // brown-green
		float(_set,TmpFloat2,0xffff000); // yellow
		float(_set,TmpFloat1,0xff7722);   // orange
		call(expset1,4,TmpFloat,TmpFloat1); //lift direction
		call(expset2,3,TmpFloat,TmpFloat2); //floor indicator	
	}
	if(VSetActive=="S3_f1_01")
	{
		if(VarKey109==0)
		{
			CurEnvTriggerSet("s3_f1_01","lite01");
			float(_set,TmpFloat,0xff2200);
			call(expset1,TmpFloat,600,-1);
			call(expset2,TmpFloat,600,-1);

			CurEnvTriggerSet("s3_f1_01","lite02");
			float(_set,TmpFloat,0xff2200);
			call(expset1,TmpFloat,600,-1);
			call(expset2,TmpFloat,600,-1);

			CurEnvTriggerSet("s3_f1_02","check");
			call(expget,1,varkey109);
			vector(_set,gactorpos,7186,911,19955);
			vector(_set,gactorine,7186,911,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,840,19955);
			vector(_set,gactorine,7186,840,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,780,19955);
			vector(_set,gactorine,7186,780,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,720,19955);
			vector(_set,gactorine,7186,720,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,660,19955);
			vector(_set,gactorine,7186,660,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,600,19955);
			vector(_set,gactorine,7186,600,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,540,19955);
			vector(_set,gactorine,7186,540,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			vector(_set,gactorpos,7186,480,19955);
			vector(_set,gactorine,7186,480,20550);
			callsub(ElectricStrip,gactorpos,gactorine,fx_red);

			if(vrnd<20)
			{
				vector(_set,gactorpos,7212,900,20526);
				vector(_set,tmpvector,255,0,0);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,300);

				vector(_set,gactorpos,7212,900,19959);
				vector(_set,tmpvector,255,0,0);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,300);
			}
		}
		else
		{
			CurEnvTriggerSet("s3_f1_02","check");
			if(VKeyObjTriggered!=0 && VKeyObjFrame<8)
			{
				call(KeyObjTrigger,12,1,-1);
				call(KeyObjActiveSegment,8,12);
			}
		}
	}
	if(VSetActive=="s3_f1b03");
	{
		if(vrnd<20)
		{
			vector(_set,tmpvector,0,0,0);
			float(_rnd2,tmpfloat,48);
			float(_sub,tmpfloat,24);
			vector(_setx,tmpvector,tmpfloat);
			float(_rnd2,tmpfloat,48);
			float(_sub,tmpfloat,24);
			vector(_sety,tmpvector,tmpfloat);
			float(_rnd2,tmpfloat,48);
			float(_sub,tmpfloat,24);
			vector(_setz,tmpvector,tmpfloat);
			vector(_set,Gactorpos,7894,-431,19173);
			vector(_add,gactorpos,tmpvector);
			SpawnParticle(fx_sparks,-1,Gactorpos,EmptyVector,-1);
			vector(_set,gactorine,3,9,0);
			spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);
			vector(_set,tmpvector,20,150,250);
			spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,300);	
		}
	}	

	if(VSetActive=="s3_gar03")
	{
		CurEnvTriggerSet("s3_gar03","lift");
		float(_set,TmpFloat,0x777711);  // brown-green
		float(_set,TmpFloat2,0xffff000); // yellow
		float(_set,TmpFloat1,0xff7722);   // orange
		call(expset1,4,TmpFloat,TmpFloat1); //lift direction
		call(expset2,3,TmpFloat,TmpFloat2); //floor indicator
		if(VKeyObjFrame==0 && VKeyObjTriggered==0 && LiftMsg==1)
		{
			message("Tank Garage",120,10);
			float(_set,LiftMsg,0);
		}
		if(VKeyObjFrame==3 && VKeyObjTriggered==0 && LiftMsg==1)
		{
			message("Factory Level",120,10);
			float(_set,LiftMsg,0);
		}
	}
	if(VSetActive=="s3_f1_02")
	{
		if(varkey109==0)
		{
			if(vrnd<20)
			{
				vector(_set,tmpvector,0,0,0);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_setx,tmpvector,tmpfloat);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_sety,tmpvector,tmpfloat);
				float(_rnd2,tmpfloat,48);
				float(_sub,tmpfloat,24);
				vector(_setz,tmpvector,tmpfloat);
				vector(_set,Gactorpos,8409,726,20631);
				vector(_add,gactorpos,tmpvector);
				SpawnParticle(fx_sparks,-1,Gactorpos,EmptyVector,-1);

				vector(_set,tmpvector,20,150,250);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,300);
			}
		}
		else
		{
			if(vrnd<20)
			{
				vector(_set,Gactorpos,8398,736,20739);
				vector(_set,gactorine,0,8,0);
				spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);

				vector(_set,Gactorpos,8398,692,20739);
				spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);

				vector(_set,Gactorpos,8398,774,20739);
				spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);
			}
		}
	}

	///////////////
	//	VCURSET	 //
	///////////////

	if(VCurSet=="s3_st10")
	{
		CurEnvTrigger("arme");
		if(VKeyObjTriggered!=0)
		{
			vector(_set,Gactorpos,565,358,17976);
			callsub(DispenserSound);
		}

		CurEnvTrigger("arme01");
		if(VKeyObjTriggered!=0)
		{
			vector(_set,Gactorpos,892,358,18347);
			callsub(DispenserSound);
		}

		CurEnvTrigger("arme02");
		if(VKeyObjTriggered!=0)
		{
			vector(_set,Gactorpos,1280,358,17990);
			callsub(DispenserSound);
		}
	}
	elseif(VCurSet=="s3_s15")
	{
		if(VarKey103==0)
		{
			CurEnvTrigger("street09");
			float(_set,TmpFloat,0xffffff);
			call(expset1,TmpFloat,350,-1);
			call(expset2,TmpFloat,350,-1);

			CurEnvTrigger("street10");
			float(_set,TmpFloat,0xffffff);
			call(expset1,TmpFloat,350,-1);
			call(expset2,TmpFloat,350,-1);
		}

		CurEnvTrigger("computer");
		if(VKeyObjFrame>=3 && VarKey103==1)
		{
			float(_set,timer3,0);
			float(_set,VarKey103,2);	
		}
		if(VarKey103==2)
		{
			float(_add,timer3,1);
			if(timer3==50)
			{
				CurEnvTrigger("street01");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==80)
			{
				CurEnvTrigger("street01");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==120)
			{
				CurEnvTrigger("street02");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==150)
			{
				CurEnvTrigger("street02");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);

				CurEnvTrigger("street07");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);

				CurEnvTrigger("street08");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);

				CurEnvTrigger("street09");
				float(_set,TmpFloat,0x228800);
				call(expset1,TmpFloat,350,-1);
				call(expset2,TmpFloat,350,-1);

				CurEnvTrigger("street10");
				float(_set,TmpFloat,0x228800);
				call(expset1,TmpFloat,350,-1);
				call(expset2,TmpFloat,350,-1);
			}
			if(timer3==180)
			{
				CurEnvTrigger("street03");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==220)
			{
				CurEnvTrigger("street03");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==250)
			{
				CurEnvTrigger("street04");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==280)
			{
				CurEnvTrigger("street04");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==320)
			{
				CurEnvTrigger("street05");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==350)
			{
				CurEnvTrigger("street05");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==380)
			{
				CurEnvTrigger("street06");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==420)
			{
				CurEnvTrigger("street06");
				float(_set,TmpFloat,0x00ff00);
				call(expset2,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3==450)
			{
				CurEnvTrigger("street07");
				float(_set,TmpFloat,0x00ff00);
				call(expset1,1,TmpFloat,0);
				sample(SFXActivate1,Gactorpos);
			}
			if(timer3>=460)
			{
				float(_set,VarKey103,3);
				float(_set,timer3,0);
			}
		}
	}

			
	elseif(VCurSet=="s3_st07")
	{
		if(vrnd<20)
		{
			vector(_set,gactorpos,10889,226,17299
			vector(_set,gactorine,0,8,8);
			spawnparticle(fx_fagsmoke,-1,gactorpos,gactorine,-1);
		}

		if(varkey107==0)
		{
			//setting radius and color of omniattach
			CurEnvTrigger("lock02");
			float(_set,TmpFloat,0x000000);
			call(expset1,TmpFloat,200,-1);
			call(expset2,TmpFloat,200,-1);

			CurEnvTrigger("lock03");
			float(_set,TmpFloat,0x000000);
			call(expset1,TmpFloat,200,-1);
			call(expset2,TmpFloat,200,-1);

			CurEnvTrigger("lock04");
			float(_set,TmpFloat,0x000000);
			call(expset1,TmpFloat,200,-1);
			call(expset2,TmpFloat,200,-1);

			CurEnvTrigger("lock05");
			float(_set,TmpFloat,0x000000);
			call(expset1,TmpFloat,200,-1);
			call(expset2,TmpFloat,200,-1);

			float(_set,varkey107,1);
		}
		if(OpenDoor==1)
		{
			CurEnvTrigger("doorup");
			call(KeyObjTrigger,255,1);
			kfsample(SFXDoOp2,SFXDoMo2,-1,SFXDoCl2);
			float(_set,OpenDoor,0);
		}

		if(varkey107>=1)
		{
         // Make sound when door hits full open position
			CurEnvTrigger("doorup");
			if (VKeyObjFrame==1 && timer4==TICKS_SCAN_DOOR_OPENED)
			{
				sample(SFXLatch2,Gactorpos);
				float(_add,timer4,1);
			}
         
			if(varkey107==2 || varkey107==3) // is in trigger and not already identified as "access denied" character?
			{
            //print ("Scanning");
				float(_set,TmpFloat,0x00ff55);
				if(timer4<=TICKS_SCAN_DOOR_OPENS)
				{
					float(_add,timer4,1);
				}
				if(timer4==TICKS_SCAN_NOTICE)
				{
					message("Scanning In Process",120,10);
					sample(SFXScanning,Gactorpos);
				}
				if(timer4==TICKS_SCAN_LIGHT_1)
				{
					CurEnvTrigger("lock02");
					call(expset1,TmpFloat,120,-1);
					call(expset2,TmpFloat,120,-1);
					sample(SFXRipple,Gactorpos);
				}
				if(timer4==TICKS_SCAN_LIGHT_2)
				{
					CurEnvTrigger("lock03");
					call(expset1,TmpFloat,120,-1);
					call(expset2,TmpFloat,120,-1);
					sample(SFXRipple,Gactorpos);
				}
				if(timer4==TICKS_SCAN_LIGHT_3)
				{
					CurEnvTrigger("lock04");
					call(expset1,TmpFloat,120,-1);
					call(expset2,TmpFloat,120,-1);
					sample(SFXRipple,Gactorpos);
				}
				if(timer4==TICKS_SCAN_LIGHT_4)
				{
					CurEnvTrigger("lock05");
					call(expset1,TmpFloat,120,-1);
					call(expset2,TmpFloat,120,-1);
					sample(SFXRipple,Gactorpos);
         			if(varkey107==2)  // Check if Was scanned as a COP
				    {
   						message("Personnel Scanned - Access Granted",120,10);
						float(_set,OpenDoor,1);
   						sample(SFXLatch2,Gactorpos);
					}
					else  // Was NOT scanned as a COP
					{
   						message("Personnel Scanned - Access DENIED",120,10);
                  
         			    float(_set,varkey107,4);   // make scanner unwind
					    float(_set,TmpFloat,0xff0000);
                  
   						CurEnvTrigger("lock02");
   						call(expset1,TmpFloat,120,-1);
   						call(expset2,TmpFloat,120,-1);
                  
   						CurEnvTrigger("lock03");
   						call(expset1,TmpFloat,120,-1);
   						call(expset2,TmpFloat,120,-1);

   						CurEnvTrigger("lock04");
   						call(expset1,TmpFloat,120,-1);
   						call(expset2,TmpFloat,120,-1);

   						CurEnvTrigger("lock05");
   						call(expset1,TmpFloat,120,-1);
   						call(expset2,TmpFloat,120,-1);
				   }
				}
			}
			elseif(varkey107==1) 
			{
				CurEnvTrigger("doorup");
            if(VKeyObjFrameNoShift==0) // Is door closed
            {
   				float(_set,TmpFloat,0x000000);
   				if(timer4>0)
   				{
      				if(timer4==TICKS_SCAN_LIGHT_1)
      				{
      					CurEnvTrigger("lock02");
      					call(expset1,TmpFloat,120,-1);
      					call(expset2,TmpFloat,120,-1);
      					sample(SFXRipple,Gactorpos);
               		float(_set,varkey107,1);   // Allow scanner to retrigger
      				}
      				if(timer4==TICKS_SCAN_LIGHT_2)
      				{
      					CurEnvTrigger("lock03");
      
      					call(expset1,TmpFloat,120,-1);
      					call(expset2,TmpFloat,120,-1);
      					sample(SFXRipple,Gactorpos);
      				}
      				if(timer4==TICKS_SCAN_LIGHT_3)
      				{
      					CurEnvTrigger("lock04");
      					call(expset1,TmpFloat,120,-1);
      					call(expset2,TmpFloat,120,-1);
      					sample(SFXRipple,Gactorpos);
      				}
      				if(timer4==TICKS_SCAN_LIGHT_4)
      				{
      					CurEnvTrigger("lock05");
      					call(expset1,TmpFloat,120,-1);
      					call(expset2,TmpFloat,120,-1);
      					sample(SFXRipple,Gactorpos);
      				}
                  if (timer4==TICKS_SCAN_DOOR_OPENS)
                  {
        				   sample(SFXLatch2,Gactorpos);
                  }
                  
   					float(_sub,timer4,1)
   				}
            }
            elseif (VKeyObjFrameNoShift>=0x10000) // if Door is closing
            {
               if (timer4>TICKS_SCAN_DOOR_OPENED) // Just started closing.
               {
                  // Turn the door lights yellow to warn that door is closing.
            		float(_set,timer4,TICKS_SCAN_DOOR_OPENS);       
                  
                  sample(SFXLatch2,Gactorpos);
                  
                  float(_set,TmpFloat,0xff1f00);
                  
                  CurEnvTrigger("lock02");
                  call(expset1,TmpFloat,120,-1);
                  call(expset2,TmpFloat,120,-1);
                  
                  CurEnvTrigger("lock03");
                  call(expset1,TmpFloat,120,-1);
                  call(expset2,TmpFloat,120,-1);

                  CurEnvTrigger("lock04");
                  call(expset1,TmpFloat,120,-1);
                  call(expset2,TmpFloat,120,-1);

                  CurEnvTrigger("lock05");
                  call(expset1,TmpFloat,120,-1);
                  call(expset2,TmpFloat,120,-1);
               }   
            }
			}
		}
	}

	if(VCurSet=="s3_s13")
	{
		CurEnvTrigger("sdoor2");
		if(VKeyObjFrame==1 && timer2==0)
		{
			vector(_set,Gactorpos,-5169,-848,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-848,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,1);
		}
		if(VKeyObjFrame==2 && timer2==1)
		{
			vector(_set,Gactorpos,-5169,-813,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-813,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,2);
		}
		if(VKeyObjFrame==3 && timer2==2)
		{
			vector(_set,Gactorpos,-5169,-765,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-765,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,3);
		}
		if(VKeyObjFrame==4 && VarKey102==3)
		{
			vector(_set,Gactorpos,-5169,-724,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-724,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,4);
		}
		if(VKeyObjFrame==5 && timer2==4)
		{
			vector(_set,Gactorpos,-5169,-691,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-691,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,5);
		}
		if(VKeyObjFrame==6 && timer2==5)
		{
			vector(_set,Gactorpos,-5169,-647,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-647,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,6);
		}
		if(VKeyObjFrame==7 && timer2==6)
		{
			vector(_set,Gactorpos,-5169,-621,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-621,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,7);
		}
		if(VKeyObjFrame==8 && timer2==7)
		{
			vector(_set,Gactorpos,-5169,-584,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-584,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,8);
		}
		if(VKeyObjFrame==9 && timer2==8)
		{
			vector(_set,Gactorpos,-5169,-551,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-551,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,9);
		}
		if(VKeyObjFrame==10 && timer2==9)
		{
			vector(_set,Gactorpos,-5169,-519,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-519,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,10);
		}
		if(VKeyObjFrame==11 && timer2==10)
		{
			vector(_set,Gactorpos,-5169,-493,17398);
			vector(_set,Gactorine,0,0,-2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-493,16797);
			vector(_set,Gactorine,0,0,2);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,VarKey102,11);
		}
		if(VKeyObjFrame==12 && VarKey102==11)
		{
			vector(_set,Gactorpos,-5169,-458,17398);
			vector(_set,Gactorine,0,0,-8);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-458,16797);
			vector(_set,Gactorine,0,0,8);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,12);
		}
		if(VKeyObjFrame==13 && timer2==12)
		{
			vector(_set,Gactorpos,-5169,-428,17398);
			vector(_set,Gactorine,0,0,-8);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-428,16797);
			vector(_set,Gactorine,0,0,8);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,13);
		}
		if(VKeyObjFrame==14 && timer2==13)
		{
			vector(_set,Gactorpos,-5169,-397,17398);
			vector(_set,Gactorine,0,0,-8);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			vector(_set,Gactorpos,-5169,-397,16797);
			vector(_set,Gactorine,0,0,8);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam)
			sample(SFXVent2,gactorpos);
			float(_set,timer2,0);
		}
	}

	//random dripping sounds
	if(VarKey105==3)
	{
		if(RandomSound<0)
		{
			float(_rnd2,RandomSound,20);
			float(_add,RandomSound,20);
			if(vrnd<15)
			{
				sample(SFXdrip1,-1);
			}
			elseif(vrnd<30)
			{
				sample(SFXdrip2,-1);
			}
			elseif(vrnd<45)
			{
				sample(SFXdrip3,-1);
			}
			elseif(vrnd<60)
			{
				sample(SFXdrip4,-1);
			}
			elseif(vrnd<75)
			{
				sample(SFXdrip5,-1);
			}
			else
			{
				sample(SFXdrip6,-1);
			}
		}
		else
		{
			float(_sub,RandomSound,1);
		}
	}
}


//	TmpFloat gets the floor number, -1 if nothing should happen
//	TmpFloat1 gets the direction the floor is moving in, 0 if not moving
//
SubRoutine(RepairLiftControl,const(CurFloor),const(NumbFloors))
{
	if(TmpFloat==-1 && VTrigger==_DIREnvTrigger)
	{
		// Direction(_clr,_DIRaction); // Don't clear it hear because panel triggers overlap.

		if(VTrigger==_DIRforward) //if CHARACTER is moving forward
		{
			float(_set,TmpFloat1,1);
			//Direction(_clr,_DIRforward); // clears the move
		}
		elseif(VTrigger==_DIRbackward) // if CHARACTER is moving backward
		{
			float(_set,TmpFloat1,-1);
			//Direction(_clr,_DIRbackward); // clears the move
		}
		else
		{
			float(_set,TmpFloat1,0);
		}

		if(TmpFloat1!=0)
		{
			float(_set,TmpFloat,CurFloor);
			float(_add,TmpFloat,TmpFloat1);

			if(TmpFloat<0 || TmpFloat>NumbFloors)
			{
				float(_set,TmpFloat,-1);
			}
		}
	}
}

SubRoutine(BackgroundTriggerChecksScene13)
{
	print("timer in lift : ",timer4);
	print("varkey107     : ",varkey107);
/////////////////////////
//// SECTOR 3 SCRIPT ////
/////////////////////////

	if(VCurSet=="s3_s01")
	{
		float(_set,VarKey105,3);
	}
	elseif(vcurset=="s3_f2_01")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}

		CurEnvTrigger("attack");
		if(VTrigger==_DIREnvTrigger && MissionLevel4==0 && VAICon==0)
		{
			vector(_set,Gactorangle,0,2048,0);
			vector(_set,Gactorpos,785,1790,19801);
			InitActor(WeaponPumpGun,Gactorpos,Gactorangle,"s3_f2_01");
			vector(_set,Gactorpos,785,1740,19801);
			InitActor(chot,Gactorpos,Gactorangle,"s3_f2_01",TRUE,20);
			
			vector(_set,Gactorangle,0,2048,0);
			vector(_set,Gactorpos,931,1790,19801);
			InitActor(WeaponPumpGun,Gactorpos,Gactorangle,"s3_f2_01");
			vector(_set,Gactorpos,931,1740,19801);
			InitActor(chot,Gactorpos,Gactorangle,"s3_f2_01",TRUE,21);
			
			vector(_set,Gactorangle,0,2048,0);
			vector(_set,Gactorpos,1086,1570,19431);
			InitActor(WeaponPumpGun,Gactorpos,Gactorangle,"s3_f2_01");
			vector(_set,Gactorpos,1086,1520,19431);
			InitActor(chot,Gactorpos,Gactorangle,"s3_f2_01",TRUE,35);
			float(_set,MissionLevel4,1);
		}									
	}
	elseif(VCurSet=="s3_f2_03")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,0,1);
			setkeyframe("S3_gar03","lift",1);
		}
	}
	elseif(VCurSet=="s3_f1b03")
	{
		CurEnvTrigger("workspawn");
		if(VTrigger==_DIREnvTrigger && VAICon!=0 && VAIClass==_AIClassWorker)
		{
			call(AIfindpathwithspecificid,2);
		}
	}
	elseif(VCurSet=="s3_f1b02")
	{
		CurEnvTrigger("CALLBUTN");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
		/*
			call(ActivateButton,"Panel Out of Order",-1,FALSE);
			call(ActivateButtonSample,SFXInvalidFunction);
			direction(_clr,_DIRaction);		
			*/
			CurEnvTriggerSet("s3_f1b01","lift");
			if(varkey101>=2)
			{
				if(VKeyObjTriggered==0 && VKeyObjFrame!=0)
				{
					call(ActivateButton,"Elevator called",0,2);
					call(ActivateButtonSample,SFXValidFunction);
					sample(SFXLatch2,Gactorpos);
				}
			}
			else
			{
				if(VarKey101==0)
				{
					call(ActivateButton,"Elevator is Already On That Floor",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
				else
				{
					call(ActivateButton,"Elevator is Out Of Order",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}	
		}
	}
	elseif(VCurSet=="s3_f1b01")
	{
		if(VarKey101==5)
		{
			message("Elevator Seriously Damaged. Maintenance Crew Called.",200,10);
			sample(SFXLiftBroken,Gactorpos);
			float(_set,VarKey101,6);
		}

		CurEnvTrigger("lift");
		if(VKeyObjFrame==1 && VKeyObjTriggered!=0 && MissionLevel2==0)
		{
			vector(_set,Gactorpos,6388,-500,16351);
			sample(SFXLiftGrind,Gactorpos);
			float(_set,MissionLevel2,1);
		}

		if(VKeyObjTriggered==0)
		{
			callsub(Sub_SetCameraNormal);
			CurEnvTrigger("doorup");
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
			{
				callsub(DoorOpen,1,1);
			}
		}
		else
		{
			Camera(elevator_camera_distance,elevator_camera_angle);
			Target(elevator_camera_Tdistance,elevator_camera_Tangle);
			float(_set,LiftMsg,1);
		}

		if(VTrigger==_DIRactionhold && VActivateButton==0 && VAICon==0)
		{
			if(VarKey101==0 || VarKey101>=2 && VarKey101<5) // not broke yet or stuck/but fixed.
			{
				float(_set,TmpFloat,-1);
				CurEnvTrigger("panel1");
				callsub(RepairLiftControl,0,3);
				CurEnvTrigger("threefeet");
				callsub(RepairLiftControl,1,3);
				CurEnvTrigger("sixfeet");
				callsub(RepairLiftControl,2,3);
				CurEnvTrigger("panel2");
				callsub(RepairLiftControl,3,3);

				CurEnvTrigger("lift");
				if(TmpFloat!=-1 && VKeyObjTriggered==0)
				{
      				Direction(_clr,_DIRaction); // clear the direction input
					Direction(_clr,_DIRforward); // clears the move
					Direction(_clr,_DIRbackward); // clears the move
               
					if(VarKey101==0)
					{
						call(ActivateButton,0,2,2); // Get Stuck
					}
					else // (VarKey101>=2)
					{
   						if(TmpFloat1==1) // Is direction up?
   						{
   							call(ActivateButton,0,3,2);
							float(_set,MissionLevel2,0);
   						}
   						else
   						{
   							call(ActivateButton,0,0,2);
   						}
					}
					if(VAICON==0)
					{
						call(ActivateButtonSample,SFXValidFunction);
					}
					float(_set,CameraPan,0);
					kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd,1);
					direction(_clr,_DIRAction);
               
					if(VarKey101<3)
					{
						float(_add,VarKey101,1); // advance to next state of repair puzzle
					}   
				}
			}
			else
			{
				float(_set,TmpFloat,-1);
				CurEnvTrigger("sixfeet");
				callsub(RepairLiftControl,2,3);
            
				CurEnvTrigger("lift");
				if(TmpFloat!=-1) // && VKeyObjTriggered==0)
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Mechanical Failure - Notify Maintenance Crew",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
				CurEnvTrigger("panel2");
				if(VarKey101>=5 && VTrigger==_DIREnvTrigger)
				{
					call(ActivateButton,"Mechanical Failure - Notify Maintenance Crew",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}  
		}
      
		CurEnvTrigger("Repair");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction && VarKey101==1 && VAICon==0) // if you're pressing the ACTION key
		{
			if(VAIClass==_AIClassWorker) //check if the CHARACTER's CLASS is : Worker
			{
				if(VWeaponType==WeaponTorch)
				{
					CutScene("camera01");
					call(PlayerInput,0);
					direction(_clr,_DIRaction);
				}
				else
				{
					message("You need a torch to fix the lift control",120,10);
				}
			}
			else
			{
				call(ActivateButton,"I need someone to help me out here !",-1,FALSE);
				call(ActivateButtonSample,SFXInvalidFunction);
			}
		}
		if(VCutSceneFrame>=20 && VCutSceneFrame<=23)
		{
			call(ActivateButton,"Welding Cables G-14 to F-27",-1,FALSE);
			call(ActivateButtonSample,SFXValidFunction);
			CurEnvTrigger("repair");
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,4,1,-1);
				call(KeyObjActiveSegment,0,4);
			}
		}
				
		if(VCutSceneFrame>=70 && VCutSceneFrame<=73)
		{
   			CurEnvTrigger("lift");
			call(KeyObjTrigger,1,-1);
      		sample(SFXLatch2,Gactorpos);
			vector(_set,Gactorpos,6388,-551,16351);
			samplestop(SFXGlobeIdle,Gactorpos);
		    float(_set,varkey101,2);   // make lift workable again.
		}
		if(VCutSceneFrame>=130 && VCutSceneFrame<=133)
		{
			message("Elevator Repaired",120,10);
		}
		if(VCutSceneFrame>=160 && VCutSceneFrame<=163)
		{
			call(PlayerInput,1);
		}
	}
	elseif(VCurSet=="s3_st06")
	{
		CurEnvTrigger("fake");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("This Door is Melted Shut",120,10);
			sample(SFXSewerPile1,-1);
		}

		//Rolls the barrel if someone kicks it.
		CurEnvTrigger("kickme");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VAIcon==0 && VAIClass!=_AIClassAngel)
			{
				if(VKeyObjFrame==0 && VTrigger==_DIRforward)
				{
					call(KeyObjTrigger,1,1);
				}
				if(VTrigger==_DIRaction && VKeyObjFrame<=1)
				{
					if(Vaction!=CopKickGeneric)
					{
						spawnaction(CopKickGeneric);
						float(_set,timer2,1);
						float(_set,timer3,0);
						direction(_clr,_DIRaction); // Necessary if character carries a weapon
					}
				}
			}
		}
		if(VKeyObjFrame!=0 && VKeyObjTriggered==0)
		{
			vector(_set,Gactorpos,8139,37,21862);
			samplestop(SFXBarrelRoll,Gactorpos);
		}
		
		if(timer2==1)
		{
			float(_add,timer3,1);
		}
		if(timer3>=5)
		{
			vector(_set,Gactorpos,8139,37,21862);
			sample(SFXBarrelRoll,Gactorpos);
			call(KeyObjTrigger,255,1);
			float(_set,timer2,0);
			float(_set,timer3,0);
		}
		CurEnvTrigger("kickme01");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRforward)
		{
			CurEnvTrigger("kickme");
			if(VKeyObjFrame==1)
			{
				call(KeyObjTrigger,0,-1);
				vector(_set,Gactorpos,8139,37,21862);
				sample(SFXBarrelRoll,Gactorpos);
			}
		}
	}
	elseif(VCurSet=="s3_st10")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{	
			callsub(DoorOpen,1,1);
		}

		if(WeaponDelay01>=1)
		{
			float(_add,WeaponDelay01,1)
			if(WeaponDelay01>=80)
			{
				CurEnvTrigger("arme");
				vector(_set,Gactorpos,565,358,17976);
				vector(_set,Gactorangle,0,0,0);
				InitActor(WeaponMaimer,Gactorpos,Gactorangle,"s3_st10",TRUE);
				call(KeyObjTrigger,255,1);
				float(_set,TmpFloat,0x0000ff);
				call(expset1,1,TmpFloat,0);	
				float(_set,WeaponDelay01,0);
			}
		}

		if(WeaponDelay02>=1)
		{
			float(_add,WeaponDelay02,1)
			if(WeaponDelay02>=80)
			{
				CurEnvTrigger("arme01");
				vector(_set,Gactorpos,912,358,18347);
				vector(_set,Gactorangle,0,0,0);
				InitActor(WeaponHarpoon,Gactorpos,Gactorangle,"s3_st10",TRUE);
				call(KeyObjTrigger,255,1);
				float(_set,TmpFloat,0x0000ff);
				call(expset1,1,TmpFloat,0);
				float(_set,WeaponDelay02,0);
			}
		}

		if(WeaponDelay03>=1)
		{
			float(_add,WeaponDelay03,1)
			if(WeaponDelay03>=80)
			{
				CurEnvTrigger("arme02");
				vector(_set,Gactorpos,1280,358,17990);
				vector(_set,Gactorangle,0,2048,0);
				InitActor(WeaponFlameThrower,Gactorpos,Gactorangle,"s3_st10",TRUE);
				call(KeyObjTrigger,255,1);
				float(_set,TmpFloat,0x0000ff);
				call(expset1,1,TmpFloat,0);
				float(_set,WeaponDelay03,0);
			}
		}	

		CurEnvTrigger("arme");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VClass!=_ClassAngel)
			{
				if(VKeyObjFrame==0 && VKeyObjTriggered==0)
				{
					call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					float(_set,WeaponDelay01,1);
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				if(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
		CurEnvTrigger("arme01");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VClass!=_ClassAngel)
			{
				if(VKeyObjFrame==0 && VKeyObjTriggered==0)
				{
					call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					float(_set,WeaponDelay02,1);
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				if(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
		CurEnvTrigger("arme02");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VClass!=_ClassAngel)
			{
				if(VKeyObjFrame==0 && VKeyObjTriggered==0)
				{
					call(ActivateButton,"Weapon Dispenser Activated",-1,FALSE);
					call(ActivateButtonSample,SFXValidFunction);
					float(_set,WeaponDelay03,1);
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Weapon Dispenser Already Activated",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				if(VAICON==0)
				{
					call(ActivateButton,"I wish I could operate that thing !",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
	}
	elseif(VCurSet=="s3_gar03")
	{
		CurEnvTrigger("lift");
		if(VKeyObjTriggered==0)
		{
			CurEnvTrigger("doorup");
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)	
			{
				callsub(DoorOpen,1,1);
			}
			CurEnvTrigger("doodn");
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)	
			{
				callsub(DoorOpen,1,1);
			}
			if(CameraPan==0)
			{
				float(_set,CameraPan,1);
			}
		}
		else
		{
			float(_set,LiftMsg,1);
		}

		if(VAICon==0)
		{
			if(CameraPan==1)
			{
				callsub(Sub_SetCameraNormal);
			}
			if(CameraPan==0)
			{
				Camera(elevator_camera_distance,elevator_camera_angle);
				Target(elevator_camera_Tdistance,elevator_camera_Tangle);
			}
		}

		if(VTrigger==_DIRactionhold && VActivateButton==0)
		{
			float(_set,TmpFloat,-1);	//must do this before calling LiftControl!
			CurEnvTrigger("panel1");
			callsub(LiftControl,0,1);
			CurEnvTrigger("panel2");
			callsub(LiftControl,1,1);

			CurEnvTrigger("lift");
			if(TmpFloat!=-1 && VKeyObjTriggered==0)			//elevator should be activated
			{
				if(TmpFloat1==1)
				{
					if(TmpFloat==1)
					{
						call(ActivateButton,0,TmpFloat,2);
						kfsample(-1,-1,-1,SFXSectorBase,1);
					}
				}
				else
				{
					if(TmpFloat==0)
					{
						call(ActivateButton,0,TmpFloat,2);
						kfsample(-1,-1,-1,SFXTankGarage,1);
					}
				}
				if(VAICON==0)
				{
					call(ActivateButtonSample,SFXValidFunction);
				}
				float(_set,CameraPan,0);
				kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd,1);
				direction(_clr,_DIRAction);
			}
		}
	}
	elseif(VCurSet=="s3_f1_05")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}
	}
	elseif(VCurSet=="s3_f1_02")
	{
		CurEnvTrigger("doordn");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,0,1);
			setkeyframe("S3_f1_03","lift",0);
			float(_set,timer2,1);
		}
		if(VKeyObjTriggered==0 && VKeyObjFrame!=1 && timer2==1)
		{
			vector(_set,Gactorine,0,5,0);
			vector(_set,Gactorpos,7913,602,19325);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam);
			vector(_set,Gactorpos,8007,602,19325);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam);
			vector(_set,Gactorpos,8101,602,19325);
			spawnparticle(fx_steam,-1,gactorpos,gactorine,fx_doorsteam);
			sample(SFXVent2,gactorpos);
			float(_set,timer2,0);
		}
	}
	elseif(VCurSet=="s3_st01")
	{
		CurEnvTrigger("door1001");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Automatic Lock Has Been Activated. Access Denied",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}

		CurEnvTrigger("door1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Automatic Lock Has Been Activated. Access Denied",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}
	}
	elseif(VCurSet=="s3_st02")
	{
		CurEnvTrigger("doordn");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}
	}
	elseif(VCurSet=="s3_st02a")
	{
		CurEnvTrigger("doordn");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}
	}
	elseif(VCurSet=="s3_st03")
	{
		CurEnvTrigger("door1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}
	}
	elseif(VCurSet=="s3_st04")
	{
		CurEnvTrigger("door2");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Door Is Out Of Order",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}
		CurEnvTrigger("gardor2");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}
		CurEnvTrigger("gardor1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}
		CurEnvTrigger("door1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Door Lock To Automatic",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}
	}
	elseif(VCurSet=="s3_st05")
	{
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}
		CurEnvTrigger("door1005");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Automatic Lock Has Been Activated. Access Denied",120,10);
			sample(SFXAccessDenied,Gactorpos);
			direction(_clr,_DIRaction);
		}
	}
	elseif(VCurSet=="s3_f1_04")
	{
		CurEnvTrigger("attack");
		if(VTrigger==_DIREnvTrigger)
		{
			CurEnvTriggerSet("s3_f1_02","check");
			if(VKeyObjTriggered==0)
			{
				call(KeyObjTrigger,7,1,-1);
				call(KeyObjActiveSegment,0,7);
			}
		}
/*
		CurEnvTrigger("diebitch");
		if(VTrigger==_DIREnvTrigger && VAIClass!=_AIClassCop)
		{
			call(AIchangeplayertoenemy);
			sample(SFXCopStopRightThere,-1);
		}
*/
		CurEnvTrigger("doorup");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Elevator Needs Further Repair. Locked For now.",200,10);
			sample(SFXAccessDenied,Gactorpos);
			float(_set,TmpFloat,0xff0000);
			call(expset1,1,TmpFloat,0);
		}

		CurEnvTrigger("fake");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Door Locked From Inside",120,10);
			sample(SFXAccessDenied,Gactorpos);
		}
	}
	elseif(VCurSet=="s3_gar01")
	{
		CurEnvTrigger("gardor1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAICon==0)
			{
				callsub(DoorOpen,2,1);
			}
		}
	}
	elseif(VCurSet=="s3_gar02")
	{
		CurEnvTrigger("doordn");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,0,1);
			setkeyframe("S3_gar03","lift",0);
		}
		CurEnvTrigger("gardor2");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}
	}
	elseif(VCurSet=="s3_f1_03")
	{
		CurEnvTrigger("lift");
		if(VKeyObjTriggered==0)
		{
			callsub(Sub_SetCameraNormal);
			CurEnvTrigger("doorup");
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
			{
				callsub(DoorOpen,1,1);
			}
			CurEnvTrigger("doordn");
			if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
			{
				callsub(DoorOpen,1,1);	
			}
		}
		else
		{
			Camera(elevator_camera_distance,elevator_camera_angle);
			Target(elevator_camera_Tdistance,elevator_camera_Tangle);
		}

		if(VTrigger==_DIRactionhold && VActivateButton==0)
		{
			if(VarKey101!=0)
			{
				float(_set,TmpFloat,-1);
				CurEnvTrigger("panel1");
				callsub(LiftControl,0,1);
				CurEnvTrigger("panel2");
				callsub(LiftControl,1,1);

				CurEnvTrigger("lift");
				if(TmpFloat!=-1 && VKeyObjTriggered==0)
				{
					if(TmpFloat1==1)
					{
						if(TmpFloat==1)
						{
							call(ActivateButton,"Laboratory",TmpFloat,2);
						//	kfsample(-1,-1,-1,SFXSectorBase,1);
						}
					}
					else
					{
						if(TmpFloat==0)
						{
							call(ActivateButton,"Factory Level",TmpFloat,2);
						//	kfsample(-1,-1,-1,SFXRadiation,1);
						}
					}
					if(VAICON==0)
					{
						call(ActivateButtonSample,SFXValidFunction);
					}
					float(_set,CameraPan,0);
					kfsample(SFXLiftStart,SFXLiftMove,-1,SFXLiftEnd,1);
					direction(_clr,_DIRAction);
				}
			}
			if(VarKey101==0 && VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
			{
				if(VAICON==0)
				{
					call(ActivateButton,"Insufficient Power - Activate The Generator",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
	}
	elseif(VCurSet=="s3_f1_01")
	{
		CurEnvTrigger("doorout");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			message("Due To Violent Riots All Exit To Outside Are Closed",120,10);
			sample(SFXAccessDenied,Gactorpos);
		}

		CurEnvTrigger("laserwall");
		if(VTrigger==_DIREnvTrigger && varkey109==0)
		{
			colstate(_or,_COLelectricity);
		}
		if(varkey109==1)
		{
			CurEnvTriggerSet("s3_f1_01","lite01");
			float(_set,TmpFloat,0x000000);
			call(expset1,TmpFloat,0,-1);
			call(expset2,TmpFloat,0,-1);

			CurEnvTriggerSet("s3_f1_01","lite02");
			float(_set,TmpFloat,0x000000);
			call(expset1,TmpFloat,0,-1);
			call(expset2,TmpFloat,0,-1);

			message("Laserwall removed",120,10);
			vector(_set,Gactorpos,8409,726,20631);
			sample(SFXPumpPower,Gactorpos);
			vector(_set,gactorpos,7186,720,20250);
			samplestop(SFXElecAmbient,Gactorpos);
			float(_set,varkey109,2);
		}
	}
	elseif(VCurSet=="s3_s03")
	{
		CurEnvTrigger("sdoor2");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VAICON==0)
			{
				message("Door locked from inside",120,10);
				sample(SFXInvalidFunction,Gactorpos);
			}
		}
	}
	elseif(VCurSet=="s3_s14")
	{
		CurEnvTrigger("door1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(varkey103==1)
			{
				callsub(DoorOpen,1,1);
			}
			else
			{
				message("It will not open...",210,10);
			}

		}
	}

	elseif(VCurSet=="S3_s12")
	{
		if(MissionLevel2==0)
		{
			float(_set,aivisiontoggle,1);
		}
		if(VarKey104==1)
		{
			float(_add,timer3,1);
			if(timer3>=70)
			{
				vector(_set,gactorpos,-7670,-880,14573);
				samplestop(SFXBurningFlesh,Gactorpos);
				vector(_set,Gactorpos,-7749,-744,14672);
				samplestop(SFXLaserAmbient,gactorpos);
				sample(SFXPumpPower,Gactorpos);
				vector(_set,Gactorpos,-7482,-779,14375);
				spawnparticle(fx_mainexplosion,-1,gactorpos,emptyvector,fx_antirotate8);
				spawnlight(flash_light,-1,Gactorpos,tmpvector,EmptyVector,1500);
				sample(SFXBazookaExplode,Gactorpos);
				float(_set,timer3,0);
				float(_set,VarKey104,2);
			}
		}
		if(VarKey104==3)
		{
			float(_add,timer3,1);
			if(timer3>=70)
			{
				vector(_set,gactorpos,-7670,-880,14573);
				sample(SFXBurningFlesh,Gactorpos);
				vector(_set,Gactorpos,-7749,-744,14672);
				sample(SFXLaserAmbient,gactorpos);
				sample(SFXPumpPowerUp,Gactorpos);
				float(_set,timer3,0);
				float(_set,VarKey104,0);
			}
		}

		CurEnvTrigger("sdoor1");
		if(VTrigger==_DIRaction && VTrigger==_DIREnvTrigger && VKeyObjTriggered==0)
		{
			if(VClass==_ClassCop && VAICon==0)
			{
				if(VarKey103>=1)
				{
					callsub(DoorOpen,1,1);
				}
				else
				{
					message("Door Remotely Closed",120,10);
					sample(SFXAccessDenied,Gactorpos);
				}
			}
			else
			{
				message("Security Personnel Only",120,10);
				sample(SFXAccessDenied,Gactorpos);
			}
		}

		CurEnvTrigger("switch");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VTrigger==_DIRaction)
			{
				if(VClass==_ClassCop)
				{
					if(VarKey104==0)
					{
						call(ActivateButton,"Laser Deactivated",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						float(_set,timer3,0);
						float(_set,VarKey104,1);
					}
					else
					{
						call(ActivateButton,"Laser Malfunction. Overheating Problem.",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Security Personnel Only",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
					direction(_clr,_DIRaction);
				}
			}
		}

		CurEnvTrigger("laserin");
		if(VTrigger==_DIREnvTrigger && VarKey104==0)
		{
			if(VClass==_ClassAngel && VState==StateCrouching)
			{
				message("Smart Boy !",120,10);
			}
			else
			{
				colstate(_or,_COLelectricity);
			}
			direction(_clr,_DIRaction);
		}
		CurEnvTrigger("laserout");
		if(VTrigger==_DIREnvTrigger && VarKey104==0)
		{
			if(VClass==_ClassAngel && VState==StateCrouching)
			{
				message("Smart Boy !",120,10);
			}
			else
			{
				colstate(_or,_COLelectricity);
			}
			direction(_clr,_DIRaction);
		}
	}
	elseif(VCurSet=="s3_s13")
	{
		CurEnvTrigger("sdoor1");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,1,1);
		}
		CurEnvTrigger("sdoor2");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			float(_set,VarKey102,0);
			callsub(DoorOpen,1,1);
			direction(_clr,_DIRaction);
		}
	}
	elseif(VCurSet=="s3_s15")
	{
		CurEnvTrigger("computer");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction);
		{
			if(VClass!=_ClassAngel)
			{
				if(VarKey103==0)
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Outskirts Power restored. Level Complete",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
						call(KeyObjTrigger,8,1,-1);
						call(KeyObjActiveSegment,4,8);
						sample(SFXPowerRestored,emptyvector);
					}
					float(_set,VarKey103,1);
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Power Already Restored",-1,FALSE);
						call(ActivateButtonSample,SFXValidFunction);
					}
				}
			}
			else
			{
				if(VAICON==0)
				{
					call(ActivateButton,"strange ....nothing happened!",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
		CurEnvTrigger("memo");
		if(VTrigger==_DIREnvTrigger && VAIcon==0 && MissionLevel2==0)
		{
			float(_set,MissionLevel2,1);
		}


		CurEnvTrigger("check");
		if(VTrigger==_DIREnvTrigger && VAICon!=0 && MissionLevel2==1)
		{
			call(PlayerInput,0);
			CutScene("choteat");
			float(_set,MissionLevel2,2);
		}

		if(MissionLevel2==2 && VCutSceneFrameEqual==125)
		{
			if(VAIClass==_AIClassChot)
			{
				sample(SFXChotGrunt,-1);
				float(_set,MissionLevel2,3);
			}
		}
		if(MissionLevel2==3 && VCutSceneFrameEqual==230)
		{
			if(VAIClass==_AIClassChot && Vaction==ChotEatCop)
			{
				spawnaction(ChotStandUpFromEat);
				vector(_set,gactorpos,8152,888,13307);
				samplestop(SFXChotEatFlesh,Gactorpos);
				float(_set,MissionLevel2,4);
			}
		}
		if(MissionLevel2==4 && VCutSceneFrameEqual==325)
		{
			call(PlayerInput,1);
			float(_set,MissionLevel2,5);
			float(_set,timer3,0);
		}
		if(MissionLevel2==5)
		{
			float(_add,timer3,1);
			if(timer3>=50)
			{
				float(_set,aivisiontoggle,0);
				float(_set,MissionLevel2,6);
				float(_set,timer3,0);
			}
		}
	}
	elseif(VCurSet=="s3_s17")
	{
		CurEnvTrigger("slamdoor");
		if(VTrigger==_DIREnvTrigger && VAICon==0)
		{
			if(VarKey110&=1)
			{
				CurEnvTrigger("opendoor");
				if(VKeyObjFrame!=1)
				{
					call(KeyObjTrigger,1,1);
					sample(SFXRustDoorClose,Gactorpos);
				}
			}
		}
		CurEnvTrigger("opendoor");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VarKey110&=1)
			{
				message("Door Locked",120,10);
				sample(SFXAccessDenied,Gactorpos);
			}
			else
			{
				if(VKeyObjFrame==1)
				{
					call(KeyObjTrigger,2,1);
				}
			}
		}
		if(VAICon==0 && VarKey110&=1)
		{
			if(VCutScene==0)
			{
				if(VarKey110&=2)
				{
					float(_and,VarKey110,0xfffffc);
					call(PlayerInput,1);				//player input on
//					float(_set,aivisiontoggle,0);		//ai vision off
//					float(_set,aitoggle,0);				//ai off
				}
				else
				{
					CurEnvTrigger("SEQTRIG");
					if(VTrigger==_DIREnvTrigger)
					{
						CutScene("chotbeh");
						call(PlayerInput,0);				//player input off
//						float(_set,aivisiontoggle,1);		//ai vision off
//						float(_set,aitoggle,1);				//ai off
						float(_or,VarKey110,2);
					}
				}
			}
		}
	}
	elseif(VCurSet=="s3_s18")
	{
		if(VAICon!=0)
		{
			if(VarKey110&=1)
			{
				Direction(_and,0);
				ActorFlag(_or,_AFLAGnoai);
			}
			else
			{
				ActorFlag(_clr,_AFLAGnoai);
			}

			if(VCutScene!=0)
			{
				if(VAIClass==_AIclasschot)
				{
					if(VRank==_RankGeneral)
					{
						if(VCutSceneFrame>30)
						{
							Direction(_or,_DIRshoot);
						}
					}
					elseif(VCutSceneFrame>10 && VAction!=CopDance)
					{
						SpawnAction(CopDance);
					}
				}

			}
		}
	}
	elseif(VCurSet=="s3_lab02")
	{
		float(_set,VarKey105,2);

		if(VarKey106==0)
		{
			vector(_set,Gactorangle,0,2048,0);
			vector(_set,Gactorpos,8000,3439,17315);
			InitActor(chotbeast,Gactorpos,Gactorangle,"s3_lab02",TRUE,3);
			float(_set,VarKey106,1);
		}

		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			CurEnvTrigger("labdoor");
			float(_set,VarKey106,2);
			direction(_clr,_DIRaction);
		}
			/*
			if(VarKey106==1)
			{
				callsub(DoorOpen,0,1);
			}
			else
			{
				message("Find Computer To Unlock The Door",120,10);
				sample(SFXInvalidFunction,Gactorpos);
			}*/

	}
	elseif(VCurSet=="s3_st07")
	{
		if(VAIcon==0)
		{
			if(MissionLevel3==0)
			{
				call(DisplayObjectives);
				float(_set,MissionLevel3,1);
			}
		}

		CurEnvTrigger("closed");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			callsub(DoorOpen,2,1);
		}

		CurEnvTrigger("embush");
		if(VTrigger==_DIREnvTrigger)
		{
			if(VAICon==0 && VarKey102==0)
			{
				float(_set,VarKey102,1);
			}
		}

		if(VarKey102==1)
		{
			vector(_set,Gactorangle,0,1024,0);
			vector(_set,Gactorpos,8567,85,21543);
			InitActor(WeaponPumpGun,Gactorpos,Gactorangle,"s3_st07");
			vector(_set,Gactorpos,8567,30,21543);
			InitActor(chot,Gactorpos,Gactorangle,"s3_st07",TRUE,15);

			vector(_set,Gactorangle,0,1024,0);
			vector(_set,Gactorpos,8215,85,21552);
			InitActor(WeaponPumpGun,Gactorpos,Gactorangle,"s3_st07");
			vector(_set,Gactorpos,8215,30,21552);
			InitActor(chot,Gactorpos,Gactorangle,"s3_st07",TRUE,16);
			float(_set,VarKey102,2);
		}

		if (varkey107>0) // If Door initialized.
		{
   			CurEnvTrigger("doorup");
   			if(VTrigger==_DIREnvTrigger) // If in trigger area
   			{
				
				GetNumbActorsInSet("s3_st07",_AIClassCop,TmpFloat);
				if(TmpFloat==0)
				{
					vector(_set,Gactorangle,0,1024,0);
					vector(_set,Gactorpos,10371,-272,16798);
					InitActor(WeaponPumpgun,Gactorpos,Gactorangle,"s3_st07",TRUE,66);
					vector(_set,Gactorpos,10371,-212,16798);
					InitActor(copl,Gactorpos,Gactorangle,"s3_st07",TRUE,66);

					CurEnvTrigger("spcheck");
					callsub(DoorOpen,1,1);
				}

				if (varkey107==1 && timer4<=0) // if trigger notice requested 
				{
          			if(VDeadAIClass==_AIClassCop || VAIClass==_AIClassCop) //check if the CHARACTER's CLASS is : COP
					{
						float(_set,varkey107,2);
					}
					else
					{
      					float(_set,varkey107,3);
					}
				}             
   			}
			else 
			{
  			   float(_set,varkey107,1);
			}
		}   
	}
	elseif(VCurSet=="s3_f1b04")
	{
      CurEnvTrigger("doorup");
      if(VAICon==0) // if not computer controlled character and lights are all out.
      {
         if(VTrigger==_DIREnvTrigger) // If in trigger area
         {
            if(VTrigger==_DIRaction) // if you're pressing the ACTION key
            {
               call(KeyObjTrigger,255,1); // run the animation of the object linked to the trigger : call(KeyObjTrigger,EndFrame,Direction)
               kfsample(SFXDoOp1,SFXDoMo1,-1,SFXDoCl1); // Plays sample for the animation KFSample(Startsound, looping sound, static(-1), EndSound)
               direction(_clr,_DIRaction); // clears the ACTION button
            }   
         }
      }
	}
	elseif(VCurSet=="s3_lab05")
	{
		CurEnvTrigger("comp01");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VClass!=_ClassAngel)
			{
				if(VAIClass==_AICLassScientist)
				{
					if(VarKey106==0)
					{
						if(VAICON==0)
						{
							call(ActivateButton,"Access To Laboratory Granted",-1,FALSE);
							call(ActivateButtonSample,SFXValidFunction);
						}
						float(_set,TmpFloat,0xffffff);
						call(expset1,1,TmpFloat,0);
						float(_set,VarKey106,1);
					}
					else
					{
						if(VAICON==0)
						{
							call(ActivateButton,"Laboratory Door locked",-1,FALSE);
							call(ActivateButtonSample,SFXValidFunction);
						}
						float(_set,TmpFloat,0x800000);
						call(expset1,1,TmpFloat,0);
						float(_set,VarKey106,0);
					}
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Authorized Lab Staff Only",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				if(VAICON==0)
				{
					call(ActivateButton,"blipp...blipp...blipp.....nothing!",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}

		CurEnvTrigger("comp02");
		if(VTrigger==_DIREnvTrigger && VTrigger==_DIRaction)
		{
			if(VClass!=_ClassAngel)
			{
				if(VAIClass==_AIclassscientist)
				{
					if(varkey108==0)
					{
						if(VarKey103!=0)
						{
							if(VAICON==0)
							{
								call(ActivateButton,"Initializing Behemoth Creation",-1,FALSE);
								call(ActivateButtonSample,SFXValidFunction);
							}
							float(_set,TmpFloat,0xffff00);
							call(expset1,1,TmpFloat,0);
							float(_set,varkey108,1);
						}
						else
						{
							if(VAICON==0)
							{
								call(ActivateButton,"Insufficient power supply. Find generator to restore power",-1,FALSE);
								call(ActivateButtonSample,SFXInvalidFunction);
							}
						}
					}
					else
					{
						if(VAICON==0)
						{
							call(ActivateButton,"Behemoth Creation Already Engaged",-1,FALSE);
							call(ActivateButtonSample,SFXValidFunction);
						}
					}
				}
				else
				{
					if(VAICON==0)
					{
						call(ActivateButton,"Authorized Lab Staff Only",-1,FALSE);
						call(ActivateButtonSample,SFXInvalidFunction);
					}
				}
			}
			else
			{
				if(VAICON==0)
				{
					call(ActivateButton,"blipp...blipp...blipp.....nothing!",-1,FALSE);
					call(ActivateButtonSample,SFXInvalidFunction);
				}
			}
		}
	}
	elseif(VCurSet=="s3_lab08")
	{
		if(VarKey106==2)
		{
			CurEnvTrigger("beast");
			if(VAIClass==_AIClassBeast)
			{
				if(VAction==ABeastIdle)
				{
					SpawnAction(ABeastTearDoorOpen);
				}
			}

			CurEnvTriggerSet("s3_lab02","labdoor");
			call(KeyObjTrigger,255,1);
			float(_set,VarKey106,3);
		}
	}
}
